/*
 * Dez threads foram criadas. Qual receberá o sinal?
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <signal.h>

#define N_THR 10

void trata_SIGTERM(int signum) {
  printf("Adeus mundo cruel!\n"); 
  signal(SIGTERM, SIG_DFL);
  raise(SIGTERM); 
}

void* f_thread(void *v) {
  int thr_id = *(int *) v; 
  sleep(3);
  printf("Thread %d.\n", thr_id);  
  return NULL; 
} 

int main() {
  sigset_t block_sigterm;
  pthread_t thr[N_THR];
  int i, id[N_THR];

 sigemptyset (&block_sigterm);
 sigaddset (&block_sigterm, SIGTERM);

 signal(SIGTERM, trata_SIGTERM);

  if (fork() == 0) {
    sleep(1);
    kill(getppid(),SIGTERM);
  }
  else {
    for (i = 0; i < N_THR; i++) {
      id[i] = i;
      pthread_create(&thr[i], NULL, f_thread, (void*) &id[i]);
    }

    sigprocmask (SIG_BLOCK, &block_sigterm, NULL);

    for (i = 0; i < N_THR; i++) 
      pthread_join(thr[i], NULL); 
  }
  return 0;
}
